<?php
namespace Pinpoint\DeliveryDate\Controller\Adminhtml\Estimated;

use Magento\Backend\App\Action;

/**
 * Class Delete
 * @package Pinpoint\DeliveryDate\Controller\Adminhtml\Estimated
 */
class Delete extends \Magento\Backend\App\Action
{
    /**
     * @var string
     */
    const ADMIN_RESOURCE = 'Pinpoint_DeliveryDate::estimated_date';

    /**
     * @var \Pinpoint\DeliveryDate\Model\EstimatedDate
     */
    protected $estimatedDate;

    /**
     * Delete constructor.
     * @param Action\Context $context
     * @param \Pinpoint\DeliveryDate\Model\EstimatedDate $estimatedDate
     */
    public function __construct(
        Action\Context $context,
        \Pinpoint\DeliveryDate\Model\EstimatedDate $estimatedDate
    ) {
        $this->estimatedDate = $estimatedDate;
        parent::__construct($context);
    }

    /**
     * @return \Magento\Backend\Model\View\Result\Redirect
     */
    public function execute()
    {
        $id = $this->getRequest()->getParam('id');
        /** @var \Magento\Backend\Model\View\Result\Redirect $resultRedirect */
        $resultRedirect = $this->resultRedirectFactory->create();
        if ($id) {
            try {
                $model = $this->estimatedDate;
                $model->load($id);
                $model->delete();

                $this->messageManager->addSuccess(__('You have deleted the estimation.'));
                return $resultRedirect->setPath('*/*/list');
            } catch (\Exception $e) {
                $this->messageManager->addError($e->getMessage());
                return $resultRedirect->setPath('*/*/edit', ['id' => $id]);
            }
        }

        $this->messageManager->addError(__('We can not find an estimation to delete.'));
        return $resultRedirect->setPath('*/*/list');
    }
}
